<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_image_crop_roi.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>vx_tutorial_image_crop_roi.c File Reference</h1><hr/><a name="_details"></a><h2>Introduction</h2>
<p>Crop a rectangular region from an image</p>
<p>In this tutorial we learn the below concepts,</p>
<ul>
<li>How to create OpenVX context and OpenVX image data object</li>
<li>How to read a BMP from handle from file and load the pixel values into the image data object</li>
<li>How to query the image data object for attributes like width, height</li>
<li>How to create an image from a rectangular region of another image</li>
<li>How to read pixel values from an image data object and save it as a BMP file</li>
<li>How to cleanup all created resources and exit the OpenVX application</li>
</ul>
<p>To include OpenVX interfaces include below file </p>
<div class="fragment"><pre class="fragment"><span class="preprocessor"> #include &lt;VX/vx.h&gt;</span>
</pre></div><p>To include utility APIs to read and write BMP file include below file </p>
<div class="fragment"><pre class="fragment"><span class="preprocessor"> #include &lt;<a class="code" href="bmp__rd__wr_8h.html">bmp_rd_wr.h</a>&gt;</span>
</pre></div><p>Follow the comments in the function <a class="el" href="vx__tutorial__image__crop__roi_8c.html#a2e40fa229aa1f3c5666a2c8f36de0e1d" title="Tutorial Entry Point.">vx_tutorial_image_crop_roi()</a> to understand this tutorial</p>
<p>As part of this tutorial, we create few utility functions as listed below. These functions will be used in subsequent tutorials to load and save images. </p>
<table frame="box" rules="all" cellspacing="0" width="50%" border="1" cellpadding="3">
<tr bgcolor="lightgrey">
<th><p>Utility function  </p>
</th><th><p>Description   </p>
</th></tr>
<tr>
<td><p><a class="el" href="vx__tutorial__image__crop__roi_8c.html#a4295a6029fd44a53594f2886c414902d" title="Load image from handle from file.">load_image_from_handle_from_file()</a>  </p>
</td><td><p>Loads an image data object from handle from file   </p>
</td></tr>
</table>

<p>Definition in file <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html">vx_tutorial_image_crop_roi.c</a>.</p>

<p><a href="vx__tutorial__image__crop__roi_8c_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__crop__roi_8c.html#a8118656bb5a60090a1dbffa402168438">IN_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;colors.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Input file name.  <a href="#a8118656bb5a60090a1dbffa402168438"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__crop__roi_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_image_crop_roi.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Output file name.  <a href="#a75506823f0db0ef3f4f022cf132dbbbb"></a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">vx_image&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__crop__roi_8c.html#a4295a6029fd44a53594f2886c414902d">load_image_from_handle_from_file</a> (vx_context context, char *filename, vx_bool convert_to_gray_scale, void **bmp_file_context)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Load image from handle from file.  <a href="#a4295a6029fd44a53594f2886c414902d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__image__crop__roi_8c.html#a2e40fa229aa1f3c5666a2c8f36de0e1d">vx_tutorial_image_crop_roi</a> ()</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tutorial Entry Point.  <a href="#a2e40fa229aa1f3c5666a2c8f36de0e1d"></a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="a8118656bb5a60090a1dbffa402168438"></a><!-- doxytag: member="vx_tutorial_image_crop_roi.c::IN_FILE_NAME" ref="a8118656bb5a60090a1dbffa402168438" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define IN_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;colors.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Input file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html#l00111">111</a> of file <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html">vx_tutorial_image_crop_roi.c</a>.</p>

</div>
</div>
<a class="anchor" id="a75506823f0db0ef3f4f022cf132dbbbb"></a><!-- doxytag: member="vx_tutorial_image_crop_roi.c::OUT_FILE_NAME" ref="a75506823f0db0ef3f4f022cf132dbbbb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define OUT_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_image_crop_roi.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Output file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html#l00114">114</a> of file <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html">vx_tutorial_image_crop_roi.c</a>.</p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a4295a6029fd44a53594f2886c414902d"></a><!-- doxytag: member="vx_tutorial_image_crop_roi.c::load_image_from_handle_from_file" ref="a4295a6029fd44a53594f2886c414902d" args="(vx_context context, char *filename, vx_bool convert_to_gray_scale, void **bmp_file_context)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">vx_image load_image_from_handle_from_file </td>
          <td>(</td>
          <td class="paramtype">vx_context&nbsp;</td>
          <td class="paramname"> <em>context</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vx_bool&nbsp;</td>
          <td class="paramname"> <em>convert_to_gray_scale</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void **&nbsp;</td>
          <td class="paramname"> <em>bmp_file_context</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Load image from handle from file. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>context</em>&nbsp;</td><td>[in] Context </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>filename</em>&nbsp;</td><td>[in] BMP filename, MUST have extension of .bmp </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>convert_to_gray_scale</em>&nbsp;</td><td>[in] vx_true_e: Converts RGB values in BMP file to 8b grayscale value and copies them to image object<br/>
 vx_false_e: Retains RGB values from BMP file and copies them to image object<br/>
 </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bmp_file_context</em>&nbsp;</td><td>[in] BMP file context</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Image data object from file. <br/>
 </dd></dl>

<p><ul>
<li>Create image from handle.</li>
</ul>
<p>Creates a reference to image object that was externally allocated </p>
<div class="fragment"><pre class="fragment">         */
        image = vxCreateImageFromHandle(context, df, image_addr, ptrs, VX_MEMORY_TYPE_HOST);
</pre></div> </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html#l00254">254</a> of file <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html">vx_tutorial_image_crop_roi.c</a>.</p>

</div>
</div>
<a class="anchor" id="a2e40fa229aa1f3c5666a2c8f36de0e1d"></a><!-- doxytag: member="vx_tutorial_image_crop_roi.c::vx_tutorial_image_crop_roi" ref="a2e40fa229aa1f3c5666a2c8f36de0e1d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void vx_tutorial_image_crop_roi </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Tutorial Entry Point. </p>

<p><ul>
<li>Define objects that we wish to create in the OpenVX application.</li>
</ul>
<p>A vx_context object is defined which is used as input parameter for all subesquent OpenVX object create APIs </p>
<div class="fragment"><pre class="fragment">     */
    vx_context context;
    vx_image image, roi_image;
    vx_uint32 width, height;
    vx_rectangle_t rect;
</pre></div><ul>
<li>Create OpenVX context.</li>
</ul>
<p>This MUST be done first before any OpenVX API call. The context that is returned is used as input for subsequent OpenVX APIs </p>
<div class="fragment"><pre class="fragment">     */
    context = vxCreateContext();
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(image);
</pre></div><ul>
<li>Create image from region of interest.</li>
</ul>
<p>Creates an image from another image given a rectangle </p>
<div class="fragment"><pre class="fragment">     */
    roi_image = vxCreateImageFromROI(image, &amp;rect);

    vxSetReferenceName((vx_reference)roi_image, <span class="stringliteral">&quot;CROP_ROI&quot;</span>);

    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(roi_image);
</pre></div><ul>
<li>Save image object to bitmap file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a>.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file()</a> to see how data in vx_image object is accessed to store pixel values from the image object to BMP file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a> </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>, roi_image);
</pre></div><ul>
<li>Release image object.</li>
</ul>
<p>Since we are done with using this image object, release it </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseImage(&amp;roi_image);
    vxReleaseImage(&amp;image);
</pre></div><ul>
<li>Release context object.</li>
</ul>
<p>Since we are done using OpenVX context, release it. No further OpenVX API calls should be done, until a context is again created using vxCreateContext() </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseContext(&amp;context);
</pre></div> </p>

<p>Definition at line <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html#l00125">125</a> of file <a class="el" href="vx__tutorial__image__crop__roi_8c_source.html">vx_tutorial_image_crop_roi.c</a>.</p>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
